if(CMAKE_CXX_COMPILER_IS_CLANG OR CMAKE_CXX_COMPILER_IS_GCC)

  if(SANITIZE_THREAD AND SANITIZE_ADDRESS)
    message(FATAL_ERROR "AddressSanitizer is not compatible with ThreadSanitizer.")
  endif()

  if(SANITIZE_ADDRESS)
    message(STATUS "AddressSanitizer enabled")
    set(SANITIZER_FLAGS "-fsanitize=address,undefined")
    check_enable_cxx_flag(-fno-sanitize=signed-integer-overflow)
  endif()

  if(SANITIZE_THREAD)
    message(STATUS "ThreadSanitizer enabled")
    set(SANITIZER_FLAGS "-fsanitize=thread")
  endif()

  if(SANITIZE_THREAD OR SANITIZE_ADDRESS)
    check_enable_cxx_flag(${SANITIZER_FLAGS})
    check_enable_cxx_flag("-fno-sanitize-recover=all")
    check_enable_cxx_flag("-fno-omit-frame-pointer")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${SANITIZER_FLAGS} -fuse-ld=gold")
  endif()
endif()

